display = {round: -1, time: "00:00:00", population: 0, contributors: 1, downloads: 0, kills: 0};



if (Meteor.isClient) {
	/////   Meteor.startup 
	// =======================
	// - initilize a client-side population of thumbnails
	// - get basic info from server about current round
	// - set up timer monitor to impose resets, when required
	//
	Meteor.startup(function () {		
		// initialize a client-side population
		test = new Population(5, Math.round(1200/DIM));
        // call server to fetch 'ROUND_INFO'
		Meteor.call('getInfo', function(e,r){
			ROUND_INFO = r;	 	 
			document.getElementById("rounDis").innerHTML = "Round: " + -1;

			// clock used for continuous updation
			DISPLAYER = self.setInterval(function(){
				document.getElementById("popuDis").innerHTML = "Population: " + POPULATION;
				document.getElementById("downDis").innerHTML = "Downloads: " + display.downloads;
				document.getElementById("killDis").innerHTML = "Removals: " + display.kills;
				document.getElementById("contDis").innerHTML = "Contributors: " + display.contributors;
			}, 100);
			
			// clock for variable updation
			UPDATER = self.setInterval(function(){
				var curr = r.end - new Date().getTime()/1000;
				var secs = Math.round(curr%60);	 	 	  	// format to "hh:mm:ss"
				var mins = Math.round(((curr-secs)/60)%(60));
				var hours = Math.round((curr-(secs + mins*60))/(60*60));
				if(secs < 10) secs = "0" + secs; 
				if(mins < 10) mins = "0" + mins;
				if(hours < 10) hours = "0" + hours;
				document.getElementById("timeDis").innerHTML = "Time: " + hours + ":" + mins + ":" + secs;
				if(curr < 0){	 	 	 	 	 	 	 	// if round has ended, reload page
					document.body.innerHTML = "Thanks for contributing! Although the current screen is all but beautiful, the server needs time to initialize a population. The page will automatically refresh shortly. If it doesn't, however, simply return back in a few minutes - the server will be ready by then for sure.";
					location.reload();
				}
				Meteor.call('quickData', function(e,r){
					display.kills = r.kills;
					display.downloads = r.downs;
				});
			}, 1000);
		});
		KILL = false;
	});
	
	
	/////   Input Monitoring
	// ===========================
	// - monitor attempts to kill image members
	document.onmousedown = function(){
		KILL = true;}
	document.onmouseup = function(){
		KILL = false;}
		
	var mie = (navigator.appName == "Microsoft Internet Explorer") ? true : false;
	if (!mie) {
		 document.captureEvents(Event.MOUSEMOVE);
		 document.captureEvents(Event.MOUSEDOWN);}
	document.onmousemove = function (e) {mousePos(e);};
	mouseX = 0;
	mouseY = 0;
	function mousePos (e) {
		if (!mie) {
			mouseX = e.pageX; 
			mouseY = e.pageY;}
		else {
			mouseX = event.clientX + document.body.scrollLeft;
			mouseY = event.clientY + document.body.scrollTop;}
			return true;
		}
		
		
	/////   Template Helpers
	// =========================
	Template.helpMenu.hints = function(){
		return [
			{key: "'d'", action: "to download"},
			{key: "click", action: "to remove"},
			{key: "'c'", action: "to copy function"},
			{key: "'e'", action: "to enlarge"},
		];
	};
	
	Template.infoMenu.contributors = function(){
		return Session.get('numberOfUsers');
	}
}


