
if (Meteor.isServer) {
	// reset round, re-populate, increment total
	beginRound = function(){
		START_TIME = new Date().getTime()/1000;
		GLEVO = [];
		KILLS = 0;
		DOWNLOADS = 0;
		TOTAL_ROUNDS++;
		for(var i = 0; i < POPULATION; i++){
			GLEVO[i] = new Evo(i);
		}
	}
	
	
	Meteor.startup(function () {
		TOTAL_ROUNDS = 0;
		TOTAL_ROUNDS = 0; // since epoch
	 	// begin first round
		beginRound();
		
		// monitor round time, restart if needed
		KEEPER = setInterval(function(){
			var currTime = new Date().getTime()/1000.0;
			if(currTime > START_TIME + ROUND_LENGTH)
				beginRound();
		}, 1000);
	
	
		Meteor.methods({
			  getPopulation: function(){
				return POPULATION;
			  },
			  
			  getThumbnail: function(n){
				if(arguments.length === 0)
					n = Math.round(Math.random()*(POPULATION-1));
				return GLEVO[n].forThumb();
			  },
			  
			  getEquation: function(n){
			  	return GLEVO[n].getFormattedEQs();
			  },
			  
			  killEvo: function(ind, pass){
			  	KILLS++;
				return GLEVO[ind].attemptKill(pass);
			  },
			  
			  getInfo: function(){
			  	var obj = {};
			  	obj.num = TOTAL_ROUNDS;
			  	obj.end = START_TIME + ROUND_LENGTH;
			  	obj.kills = KILLS;
			  	return obj;
			  },
			  
			  loadFull: function(ind, sideLen){
			  	var obj = {};
			  	obj.pixels = GLEVO[ind].getFull(sideLen);
			  	return obj;
			  },
			  
			  download: function(){
			  	DOWNLOADS++;
			  },
			  
			  quickData: function(){
			  	var obj = {};
			  	obj.kills = KILLS;
			  	obj.downs = DOWNLOADS;
			  	return obj;
			  }
		});
	});
  
  
	/////   NODE POSSIBILITIES
	// =========================
	// -> pointMutate(prob)
	// -> = oth1.cross(oth2)
	// -> = clone(oth)
	// -> morph(prob[-1,1])
	// -> vary();
	descendent = function(){
		
		// get base (either a clone or cross
		var out = randomGen().clone();
		if(Math.random(1) < .6)
			out = out.cross(randomGen());
		
		// alter/mutate/vary
		var ran = Math.random(1);
		if(ran < .33)      out.vary();
		else if(ran < .66) out.morph(Math.random(1)*1.5 - .75);
		else			   out.pointMutate(.15);
		return out;
	}
	
	
	// gets a random genome reference out of the population of evos
	randomGen = function(){
		var ind = Math.round(Math.random(1)*(POPULATION-1));
		var ran = Math.random(1);
		if(ran < .33)
			return GLEVO[ind].rgen;
		else if(ran < .66)
			return GLEVO[ind].ggen;
		return GLEVO[ind].bgen;
	}
}
